﻿using Kivii;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Njzj.Ngstc
{
    [Api(Description = "珠宝结算明细")]
    public class NgstcDetail
    {
        [ApiMember(Description = "客户简称")]
        public string CShortName { get; set; }

        [ApiMember(Description = "客户全称")]
        public string CName { get; set; }

        [ApiMember(Description = "区域")]
        public string Region { get; set; }

        [ApiMember(Description = "批次号")]
        public string BatchNo { get; set; }

        [ApiMember(Description = "收样日期")]
        public string TabDate { get; set; }

        [ApiMember(Description = "业务类型,证书或分称")]
        public string BillType { get; set; }

        [ApiMember(Description = "来源")]
        public string Source { get; set; }

        [ApiMember(Description = "收样件数")]
        public decimal Amount { get; set; }

        [ApiMember(Description = "完成件数")]
        public decimal AmountComplete { get; set; }

        [ApiMember(Description = "克重")]
        public decimal Weight { get; set; }

        [ApiMember(Description = "原始价")]
        public decimal OriPrice { get; set; }

        [ApiMember(Description = "结算价")]
        public decimal CurPrice { get; set; }
    }

    public class NgstcResponse
    {
        public int code { get; set; }
        public string msg { get; set; }
        public List<NgstcDetail> SFBillInfos { get; set; }
    }

    public class NgstcUpdate
    {
        [ApiMember(Description = "收款单号")]
        public string BillNo { get; set; }

        [ApiMember(Description = "未付金额")]
        public decimal UnPaid { get; set; }

        [ApiMember(Description = "已付金额")]
        public decimal Paid { get; set; }

        [ApiMember(Description = "收款状态")]
        public string BillState { get; set; }

        [ApiMember(Description = "收款日期")]
        public DateTime PayDate { get; set; }

        [ApiMember(Description = "备注")]
        public string Remark { get; set; }
    }
}
